/*
 * info.h
 *
 * Copyright (C) 2006  Insigme Co., Ltd
 *
 * This software has been developed while working on the Linux Unified Kernel
 * project (http://www.longene.org) in the Insigma Research Institute,  
 * which is a subdivision of Insigma Co., Ltd (http://www.insigma.com.cn).
 * 
 * The project is sponsored by Insigma Co., Ltd.
 *
 * The authors can be reached at linux@insigma.com.cn.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of  the GNU General  Public License as published by the
 * Free Software Foundation; either version 2 of the  License, or (at your
 * option) any later version.
 *
 * Revision History:
 *   Dec 2008 - Created.
 */

/* 
 * info.h:
 * Refered to Wine code
 */
#ifndef _WINESERVER_INFO_H
#define _WINESERVER_INFO_H

#include "object.h"
#include "process.h"
#include <asm/atomic.h>

#ifdef CONFIG_UNIFIED_KERNEL
struct handle_info
{
    void            *obj;
    int             unix_fd;
};

int set_handle_info(struct eprocess *process, obj_handle_t handle, void *obj);
struct handle_info *get_handle_info(struct eprocess *process, obj_handle_t handle);
int get_handle_fd(struct eprocess *process, obj_handle_t handle);
void clear_handle_info(struct eprocess *process, obj_handle_t handle);
struct handle_info_table *alloc_handle_info_table(void);
void free_handle_info_table(struct handle_info_table *table);

struct handle_info_table
{
    unsigned long       used;       /* used size */
    int                 order;      /* page orders */
    unsigned long       allocated;  /* available size */
    struct handle_info  *handles;
};

#endif
#endif /* _WINESERVER_INFO_H */
