/*
 * misc.c
 *
 * Copyright (C) 2006  Insigme Co., Ltd
 *
 * This software has been developed while working on the Linux Unified Kernel
 * project (http://www.longene.org) in the Insigma Research Institute,  
 * which is a subdivision of Insigma Co., Ltd (http://www.insigma.com.cn).
 * 
 * The project is sponsored by Insigma Co., Ltd.
 *
 * The authors can be reached at linux@insigma.com.cn.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of  the GNU General  Public License as published by the
 * Free Software Foundation; either version 2 of the  License, or (at your
 * option) any later version.
 *
 * Revision History:
 *   Jan 2006 - Created.
 */

/* 
 * misc.c:
 */

#include <linux/time.h>
#include <linux/winternl.h>
#include "win32.h"
#include "object.h"

#ifdef CONFIG_UNIFIED_KERNEL
#define WINNT_DAY_BEFORE 134774 /* days from 1601.1.1 to 1970.1.1 */

void query_sys_time(large_integer_t *CurrentTime)
{
	struct timespec unix_time;
	long long temp;
 
	/* need EXPORT_SYMBOL. kernel/posix-timers.c */
	do_posix_clock_monotonic_gettime(&unix_time);

	temp = WINNT_DAY_BEFORE * 24;
	CurrentTime->quad = (temp * 3600 + unix_time.tv_sec) * 10000000;
	CurrentTime->quad += unix_time.tv_nsec / 100;
}
EXPORT_SYMBOL(query_sys_time);


/* stubs from Wine server */
struct process_snapshot *process_snap( int *count )
{
	return NULL;
}

struct module_snapshot *module_snap( struct w32process *process, int *count )
{
	return NULL;
}

struct thread_snapshot *thread_snap( int *count )
{
	return NULL;
}

void enum_processes(int (*cb)(struct w32process*, void*), void *user)
{
}

struct object_type *no_get_type( struct object *obj )
{
    kdebug("ERR: no_get_type() gets called!\n");
	return NULL;
}

void no_destroy( struct object *obj )
{
	kdebug("ERR: no_destroy() gets called!\n");
}

#endif
